Package opennlp.tools.namefind

# Class DefaultNameContextGenerator

java.lang.Object
opennlp.tools.namefind.DefaultNameContextGenerator

All Implemented Interfaces:
  `NameContextGenerator`, `BeamSearchContextGenerator<String>`

public class DefaultNameContextGenerator extends Object implements NameContextGenerator
A `NameContextGenerator` implementation for determining contextual features for a `tag-chunk` style named-entity recognizer.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultNameContextGenerator(AdaptiveFeatureGenerator... featureGenerators)`
  Creates a name context generator with the specified `feature generators`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addFeatureGenerator(AdaptiveFeatureGenerator generator)`
  Adds a feature generator.
  `void`
  `clearAdaptiveData()`
  Informs all the feature generators that the context of the adaptive data (typically a document) is no longer valid and should be cleared.
  `String[]`
  `getContext(int index, String[] tokens, String[] preds, Object[] additionalContext)`
  Finds the context for finding names at the specified index.
  `void`
  `updateAdaptiveData(String[] tokens, String[] outcomes)`
  Informs all the feature generators that the specified `tokens` have been classified with the corresponds set of specified `outcomes`.

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DefaultNameContextGenerator

    public DefaultNameContextGenerator(AdaptiveFeatureGenerator... featureGenerators)
    Creates a name context generator with the specified `feature generators`.
    Parameters:
      `featureGenerators` - One or more `feature generators`.

- ## Method Details

  - ### addFeatureGenerator

    public void addFeatureGenerator(AdaptiveFeatureGenerator generator)
    Description copied from interface: `NameContextGenerator`
    Adds a feature generator.
    Specified by:
      `addFeatureGenerator` in interface `NameContextGenerator`
    Parameters:
      `generator` - The `feature generator` to add.

  - ### updateAdaptiveData

    public void updateAdaptiveData(String[] tokens, String[] outcomes)
    Description copied from interface: `NameContextGenerator`
    Informs all the feature generators that the specified `tokens` have been classified with the corresponds set of specified `outcomes`.
    Specified by:
      `updateAdaptiveData` in interface `NameContextGenerator`
    Parameters:
      `tokens` - The tokens of a sentence or another text unit which has been processed.
      `outcomes` - The outcomes associated with the specified `tokens`.

  - ### clearAdaptiveData

    public void clearAdaptiveData()
    Description copied from interface: `NameContextGenerator`
    Informs all the feature generators that the context of the adaptive data (typically a document) is no longer valid and should be cleared.
    Specified by:
      `clearAdaptiveData` in interface `NameContextGenerator`

  - ### getContext

    public String[] getContext(int index, String[] tokens, String[] preds, Object[] additionalContext)
    Finds the context for finding names at the specified index.
    Specified by:
      `getContext` in interface `BeamSearchContextGenerator<String>`
    Parameters:
      `index` - The index of the token in the specified `tokens` for which the context should be constructed.
      `tokens` - The tokens of the sentence. The `toString()` methods of these objects should return the token text.
      `preds` - The previous decisions made in the tagging of this sequence. Only indices less than `index` will be examined.
      `additionalContext` - Addition features which may be based on a context outside the sentence.
    Returns:
      The context for finding names at the specified `index`.